"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@tangential/core");
var isNumeric_1 = require("rxjs/util/isNumeric");
var configurable_input_type_1 = require("../configurable-input-type");
var number_ival_1 = require("./number-ival");
var Model = {
    min: 0,
    max: 100,
    step: 1,
    decimalPlaces: 1,
    defaultValue: 50
};
var NumberType = (function (_super) {
    __extends(NumberType, _super);
    function NumberType(config, key) {
        return _super.call(this, config || {}, key) || this;
    }
    NumberType.prototype.getInputTypeKey = function () {
        return NumberType.TYPE_NAME;
    };
    NumberType.prototype.isNumeric = function () {
        return true;
    };
    NumberType.prototype.createValue = function (cfg, key) {
        cfg = cfg || {};
        return new number_ival_1.NumberIval({
            value: isNumeric_1.isNumeric(cfg.value) ? cfg.value : this.defaultValue
        }, key || this.$key);
    };
    return NumberType;
}(configurable_input_type_1.ConfigurableInputType));
NumberType.$model = core_1.ObjectUtil.assignDeep({}, configurable_input_type_1.ConfigurableInputType.$model, Model);
NumberType.TYPE_NAME = 'Number';
exports.NumberType = NumberType;
configurable_input_type_1.ConfigurableInputType.register(NumberType);

//# sourceMappingURL=number-type.js.map
