"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
var BehaviorSubject_1 = require("rxjs/BehaviorSubject");
var input_types_registry_1 = require("../input-types-registry");
var input_view_mode_1 = require("../input-view-mode");
var ChooseInputWidgetDialog = (function () {
    function ChooseInputWidgetDialog(_registry, dialogRef) {
        var _this = this;
        this._registry = _registry;
        this.dialogRef = dialogRef;
        this.flexL = 'column';
        this.flexLA = 'start';
        this._height = '100%';
        this._width = '100%';
        this.mw = '100%';
        this.templates = [];
        this.filteredTemplates = [];
        this.filterSubject = new BehaviorSubject_1.BehaviorSubject('');
        this.templates = this._registry.allTemplates(input_view_mode_1.InputViewModes.EDIT).map(function (template) {
            template.config = template.config.getDemoInstance();
            return template;
        });
        this.filteredTemplates = this.templates;
        this.filterSubject = new BehaviorSubject_1.BehaviorSubject('');
        this.filterSubject.debounceTime(100).subscribe(function (filterText) {
            _this._filterWidgets(filterText);
        });
    }
    ChooseInputWidgetDialog.prototype._filterWidgets = function (filterText) {
        if (filterText === '') {
            this.filteredTemplates = this.templates;
        }
        else {
            this.filteredTemplates = this.templates.filter(function (template) {
                return template.config._inputName.toLowerCase().indexOf(filterText.toLowerCase()) > -1;
            });
        }
    };
    ChooseInputWidgetDialog.prototype.onFilterTextChange = function (filter) {
        this.filterSubject.next(filter);
    };
    ChooseInputWidgetDialog.prototype.onWidgetClicked = function (inputTemplate) {
        this.dialogRef.close(inputTemplate);
    };
    return ChooseInputWidgetDialog;
}());
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], ChooseInputWidgetDialog.prototype, "flexL", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], ChooseInputWidgetDialog.prototype, "flexLA", void 0);
__decorate([
    core_1.HostBinding('style.height'),
    __metadata("design:type", Object)
], ChooseInputWidgetDialog.prototype, "_height", void 0);
__decorate([
    core_1.HostBinding('style.width'),
    __metadata("design:type", String)
], ChooseInputWidgetDialog.prototype, "_width", void 0);
__decorate([
    core_1.HostBinding('style.max-width'),
    __metadata("design:type", Object)
], ChooseInputWidgetDialog.prototype, "mw", void 0);
ChooseInputWidgetDialog = __decorate([
    core_1.Component({
        selector: 'choose-input-widget-dialog',
        template: "<div class=\"tanj-dialog-title\" layout=\"row\" layout-align=\"center\"> <h2 i18n>Choose a widget</h2> </div> <div class=\"tanj-dialog-content-container\"> <div flex=\"grow\" class=\"tanj-dialog-content\" layout=\"column\" layout-align=\"center\"> <div md-dialog-actions class=\"tanj-widget-list tanj-example-widget\" flex layout=\"column\" layout-align=\"start\"> <div *ngFor=\"let inputTemplate of filteredTemplates\" class=\"tanj-widget-container\" flex=\"grow\" layout=\"row\" layout-align=\"start center\"> <tanj-input-template-container flex [inputConfig]=\"inputTemplate.config\" [inputIval]=\"inputTemplate.ival\" [mode]=\"inputTemplate.mode\"></tanj-input-template-container> <div class=\"tanj-widget-button-container\" layout=\"row\" layout-align=\"end center\"> <a md-mini-fab (click)=\"onWidgetClicked(inputTemplate)\"> <tanj-icon ligature=\"done\"></tanj-icon> </a> </div> </div> </div> </div> </div> ",
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [input_types_registry_1.InputRegistry, material_1.MdDialogRef])
], ChooseInputWidgetDialog);
exports.ChooseInputWidgetDialog = ChooseInputWidgetDialog;

//# sourceMappingURL=choose-input-widget-dialog.js.map
