import { AfterViewInit, ComponentFactoryResolver, EventEmitter, NgZone, OnChanges, OnDestroy, SimpleChange } from '@angular/core';
import { ConfigurableInputIval } from '../../../data-type/configurable-input-ival';
import { InputConfig } from '../../../input-config';
import { InputRegistry } from '../../input-types-registry';
import { InputViewMode } from '../../input-view-mode';
import { InputTemplateIF } from './input-template.component';
import { InputTemplateDirective } from './input-template.directive';
export declare class InputTemplateContainerComponent implements AfterViewInit, OnChanges, OnDestroy {
    private _typeRegistry;
    private _componentFactoryResolver;
    private _zone;
    template: InputTemplateIF;
    inputConfig: InputConfig;
    inputIval: ConfigurableInputIval;
    mode: InputViewMode;
    hideLabel?: boolean;
    onlyLabel?: boolean;
    change: EventEmitter<any>;
    inputItemHost: InputTemplateDirective;
    private _componentRef;
    constructor(_typeRegistry: InputRegistry, _componentFactoryResolver: ComponentFactoryResolver, _zone: NgZone);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: {
        template: SimpleChange;
    }): void;
    loadComponent(): void;
}
